=== tests/run-make/no-input-file/Makefile ===
include ../tools.mk

all:
	$(RUSTC) --print crate-name 2>&1 | diff - no-input-file.stderr
