=== debian/control ===
--- 
+++ 
@@ -13,25 +13,34 @@
  debhelper-compat (= 13),
  dpkg-dev (>= 1.17.14),
  python3:native,
- cargo:native (>= 0.60.0)      <!pkg.rustc.dlstage0>,
- rustc:native (>= 1.69.0+dfsg) <!pkg.rustc.dlstage0>,
- rustc:native (<= 1.70.0++)    <!pkg.rustc.dlstage0>,
+ cargo:native (>= 1.70.0+dfsg)      <!pkg.rustc.dlstage0>,
+ rustc:native (>= 1.70.0+dfsg) <!pkg.rustc.dlstage0>,
+ rustc:native (<= 1.71.1++)    <!pkg.rustc.dlstage0>,
  llvm-16-dev:native,
  llvm-16-tools:native,
  gcc-mingw-w64-x86-64-posix:native [amd64] <!nowindows>,
  gcc-mingw-w64-i686-posix:native [i386] <!nowindows>,
  libllvm16t64 (>= 1:16.0.0),
  libclang-rt-16-dev:native,
- cmake (>= 3.0) | cmake3,
+ cmake (>= 3.0),
 # needed by some vendor crates
- pkg-config,
+ pkgconf,
 # this is sometimes needed by rustc_llvm
  zlib1g-dev:native,
  zlib1g-dev,
 # used by rust-installer
  liblzma-dev:native,
+# used by cargo
+ bash-completion,
+ libcurl4-openssl-dev | libcurl4-gnutls-dev,
+ libssh2-1-dev,
+ libssl-dev,
+ libgit2-dev (>= 1.7.1),
+ libgit2-dev (<< 1.8~~),
+ libhttp-parser-dev,
 # test dependencies:
  binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
+# temporarily disabled cause of #1066794 / t64 transition
  git <!nocheck>,
  procps <!nocheck>,
 # below are optional tools even for 'make check'
@@ -41,6 +50,7 @@
  ca-certificates <pkg.rustc.dlstage0>,
 Build-Depends-Indep:
  wasi-libc (>= 0.0~git20230113.4362b18-2~) <!nowasm>,
+ wasi-libc (<= 0.0~git20230113.4362b18++) <!nowasm>,
  clang-16:native,
 Build-Conflicts: gdb-minimal <!nocheck>
 Standards-Version: 4.6.2
@@ -56,12 +66,9 @@
  libstd-rust-dev (= ${binary:Version}),
  gcc, libc-dev, binutils (>= 2.26)
 Recommends:
- cargo (>= 0.71.0~~), cargo (<< 0.72.0~~),
+ cargo (= ${binary:Version}),
 # llvm is needed for llvm-dwp for -C split-debuginfo=packed
- llvm-16,
-Suggests:
-# lld and clang are needed for wasm compilation
- lld-16, clang-16,
+ rust-llvm,
 Replaces: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
 Breaks: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
 Description: Rust systems programming language
@@ -77,7 +84,7 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-1.70
+Package: libstd-rust-1.71
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -104,7 +111,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends},
- libstd-rust-1.70 (= ${binary:Version}),
+ libstd-rust-1.71 (= ${binary:Version}),
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -220,6 +227,38 @@
  This package contains pretty printers and a wrapper script for
  invoking lldb on rust binaries.
 
+Package: rust-llvm
+Architecture: all
+Breaks:
+ rustc (<< 1.71.1+dfsg1-1~exp1),
+ rust-web (<< 1.71.1+dfsg1-1~exp1),
+ rust-mozilla (<< 1.71.1+dfsg1-1~exp1),
+Replaces:
+ rustc (<< 1.71.1+dfsg1-1~exp1),
+ rustc-web (<< 1.71.1+dfsg1-1~exp1),
+ rustc-mozilla (<< 1.71.1+dfsg1-1~exp1),
+Depends:
+ ${misc:Depends},
+# lld and clang are needed for wasm compilation
+ lld-16, clang-16,
+# llvm is needed for llvm-dwp for split-debuginfo=packed
+ llvm-16
+Description: Rust LLVM integration
+ Rust is a curly-brace, block-structured expression language.  It
+ visually resembles the C language family, but differs significantly
+ in syntactic and semantic details.  Its design is oriented toward
+ concerns of "programming in the large", that is, of creating and
+ maintaining boundaries - both abstract and operational - that
+ preserve large-system integrity, availability and concurrency.
+ .
+ It supports a mixture of imperative procedural, concurrent actor,
+ object-oriented and pure functional styles.  Rust also supports
+ generic programming and meta-programming, in both static and dynamic
+ styles.
+ .
+ This package contains symlinks for integration with LLVM tools such as lld and
+ grcov.
+
 Package: rust-doc
 Section: doc
 Architecture: all
@@ -257,35 +296,3 @@
  .
  It supports a mixture of imperative procedural, concurrent actor,
  object-oriented and pure functional styles.  Rust also supports
- generic programming and meta-programming, in both static and dynamic
- styles.
- .
- This package contains sources of the Rust compiler and standard
- libraries, useful for IDEs and code analysis tools such as Racer.
-
-Package: rust-clippy
-Architecture: any
-Multi-Arch: allowed
-Depends: ${misc:Depends}, ${shlibs:Depends},
- libstd-rust-1.70 (= ${binary:Version})
-Recommends: cargo
-Description: Rust linter
- Rust is a curly-brace, block-structured expression language.  It
- visually resembles the C language family, but differs significantly
- in syntactic and semantic details.  Its design is oriented toward
- concerns of "programming in the large", that is, of creating and
- maintaining boundaries - both abstract and operational - that
- preserve large-system integrity, availability and concurrency.
- .
- It supports a mixture of imperative procedural, concurrent actor,
- object-oriented and pure functional styles.  Rust also supports
- generic programming and meta-programming, in both static and dynamic
- styles.
- .
- This package contains 'clippy', a linter to catch common mistakes and improve
- your Rust code as well a collection of over 400 compatible lints.
- .
- Lints are divided into categories, each with a default lint level. You can
- choose how much Clippy is supposed to annoy help you by changing the lint
- level by category.
- .
