=== debian/rules ===
--- 
+++ 
@@ -36,6 +36,8 @@
 # Use system LLVM (comment out to use vendored LLVM)
 LLVM_VERSION = 16
 OLD_LLVM_VERSION = 15
+# Cargo-specific flags
+export LIBSSH2_SYS_USE_PKG_CONFIG=1
 # Make it easier to test against a custom LLVM
 ifneq (,$(LLVM_DESTDIR))
 LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
@@ -52,7 +54,7 @@
 CLANG_RT_ARCH = armhf
 endif
 
-ifneq (,$(filter $(DEB_TARGET_ARCH), sparc64 mips64el)))
+ifneq (,$(filter $(DEB_TARGET_ARCH),sparc64 mips64el))
 # sparc64: see https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1061125
 # mips64el: has profiler, but buggy atm (32-bit overflow in some counter?)
 CLANG_RT_ARCH =
@@ -198,7 +200,7 @@
 endif
 
 %:
-	$(SYSTEM_WORKAROUNDS) dh $@ --parallel
+	$(SYSTEM_WORKAROUNDS) dh $@ --parallel --with bash-completion
 
 .PHONY: .dbg-windows
 .dbg-windows:
@@ -206,10 +208,6 @@
 
 .PHONY: build
 build:
-	$(SYSTEM_WORKAROUNDS) dh $@ --parallel
+	$(SYSTEM_WORKAROUNDS) dh $@ --parallel --with bash-completion
 
 override_dh_clean:
-	# Upstream contains a lot of these
-	dh_clean -XCargo.toml.orig
-
-debian/config.toml: debian/config.toml.in debian/rules
